﻿using Eto.Forms;
using Rhino;
using System.Runtime.InteropServices;
using Label = Eto.Forms.Label;

namespace CSProjectTemplate
{
    [Guid("d53ef36a-e9ba-4be7-b61c-8ac21c618783")]
    internal class BuildPanel : EtoPanel
    {
        public BuildPanel(PanelViewModel panelViewModel) : base(panelViewModel)
        {

            DropDown drpDimensionStyleHeader = new DropDown()
            {
                ID = "drpDimensionStyleHeader",
            };

            RhinoDoc.CloseDocument += BuildPanelController.RhinoDocOnCloseDocument;
            RhinoDoc.DimensionStyleTableEvent += BuildPanelController.RhinoDocOnDimensionStyleTableEvent;
            this.LoadComplete += (sender, e) => BuildPanelController.BuildPanel_OnLoadComplete(sender, e );

            var layout = new DynamicLayout();
            layout.BeginScrollable();
            layout.ID = "Tbl01";
            layout.AddRow(new TableLayout()
            {
                Rows =
                    {
                        new TableRow(new TableCell(drpDimensionStyleHeader)),
                        new TableRow() {ScaleHeight = true},
                    }
            }
            );

            layout.EndScrollable();
            Content = layout;

        }
    }
}