﻿using System;
using System.Linq;
using Eto.Forms;
using Rhino;
using Rhino.DocObjects.Tables;
using Rhino.UI;

namespace CSProjectTemplate
{
    internal class BuildPanelController : EtoPanel
    {
        private static readonly RhinoDoc Doc = RhinoDoc.ActiveDoc;
        private static Panel _panel;

        public BuildPanelController(PanelViewModel panelViewModel) : base(panelViewModel)
        {
        }

        public static void RhinoDocOnCloseDocument(object sender, DocumentEventArgs e)
        {
            Panels.ClosePanel(typeof(MainPanel).GUID);
        }

        ///ToDo; Dale put break point here
        public static void RhinoDocOnDimensionStyleTableEvent(object sender, DimStyleTableEventArgs args)
        {
            switch (args.EventType)
            {
                case DimStyleTableEventType.Added:
                case DimStyleTableEventType.Undeleted:
                case DimStyleTableEventType.Modified:
                    DrpDimensionStyleHeaderSetup();
                    break;
            }
        }

        public static void BuildPanel_OnLoadComplete(object sender, EventArgs eventArgs)
        {
            _panel = (Panel) sender;
           
            DrpDimensionStyleHeaderSetup();
        }

        ///ToDo: Failure point: Tried to load the selectionKey of this combo box with current name and at this point in the cycle there is none
        ///ToDo: This triggers the error Rhino.Runtime.DocumentCollectedException and exposes internal structures.
        public static void DrpDimensionStyleHeaderSetup()
        {
            DropDown drpDimensionStyleHeader = (DropDown) _panel.Children.First(i => i.ID == "drpDimensionStyleHeader");
            drpDimensionStyleHeader.Items.Clear();
            foreach (var dimStyles in Doc.DimStyles.Where(ds => ds.IsDeleted == false))
            {
                drpDimensionStyleHeader.Items.Add(dimStyles.Name);
            }

            //ToDo: Still and active doc
            drpDimensionStyleHeader.SelectedKey = Doc.DimStyles.Current.Name;
            return;
        }
    }
}