﻿using Eto.Forms;
using System.Windows.Input;

namespace CSProjectTemplate
{
    public class PanelViewModel : Rhino.UI.ViewModel
    {
        private Control _content;
        private EtoPanel[] _panelList;

        public PanelViewModel(uint documentRuntimeSerialNumber)
        {
            BuildCommand = new RelayCommand<object>(obj => { BuildButtonCommand(); });
        }

        private void BuildButtonCommand()
        {
            Content = _panelList[0];
        }

        public ICommand BuildCommand { get; }

        public void SetPanel(int panel)
        {
            _panelList = new EtoPanel[]
            {
                new BuildPanel(this),
            };

            Content = _panelList[panel];
        }

        public Control Content
        {
            get { return _content; }
            set
            {
                if (_content == value)
                {
                    return;
                }

                _content = value;
                RaisePropertyChanged(nameof(Content));
            }
        }
    }
}